Module org.firebirdsql.jaybird
Package org.firebirdsql.gds.impl

# Class GDSFactory

java.lang.Object
org.firebirdsql.gds.impl.GDSFactory

public final class GDSFactory extends Object
The class `GDSFactory` exists to provide a way to obtain objects implementing GDS and Clumplet.

Author:
  David Jencks, Mark Rotteveel

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Class<?>`
  `getConnectionClass(GDSType gdsType)`
  Get class extending the `FBConnection` that will be instantiated when new connection is created.
  `static FbDatabaseFactory`
  `getDatabaseFactoryForType(GDSType gdsType)`
  `static String`
  `getDatabasePath(GDSType gdsType, String jdbcUrl)`
  Get path to the database from the specified JDBC URL.
  `static String`
  `getDatabasePath(GDSType gdsType, String server, Integer port, String path)`
  Get connection string for the specified server name, port and database name/path.
  `static GDSType`
  `getDefaultGDSType()`
  Get default GDS type.
  `static String`
  `getJdbcUrl(GDSType gdsType, DatabaseConnectionProperties dbConnectionProperties)`
  Create JDBC URL for the specified GDS type and database connection properties.
  `static GDSFactoryPlugin`
  `getPlugin(GDSType gdsType)`
  Get plugin for the specified GDS type.
  `static Set<String>`
  `getSupportedProtocols()`
  Get collection of the supported JDBC protocols.
  `static GDSType`
  `getTypeForProtocol(String jdbcUrl)`
  Get GDS type for the specified JDBC URL.
  `static void`
  `registerPlugin(GDSFactoryPlugin plugin)`
  Register plugin for this factory.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### registerPlugin

    public static void registerPlugin(GDSFactoryPlugin plugin)
    Register plugin for this factory. Usually there is no need to register plugins, since this happens automatically during initialization of this class. However, there might be a situation when automatic plugin registration does not work.
    Parameters:
      `plugin` - instance of `GDSFactoryPlugin` to register.

  - ### getDefaultGDSType

    public static GDSType getDefaultGDSType()
    Get default GDS type.
    Returns:
      instance of `GDSType`.

  - ### getDatabaseFactoryForType

    public static FbDatabaseFactory getDatabaseFactoryForType(GDSType gdsType)

  - ### getDatabasePath

    public static String getDatabasePath(GDSType gdsType, String server, Integer port, String path) throws SQLException
    Get connection string for the specified server name, port and database name/path. This method delegates call to the factory plugin corresponding to the specified type.
    Parameters:
      `gdsType` - instance of `GDSType` for which connection string should be returned.
      `server` - name or IP address of the database server, applies only to IPC and TCP connection modes, in other cases should be `null`.
      `port` - port on which database server opened listening socket, applies to TCP connection mode only, may be `null`.
      `path` - database name or path to the database
    Returns:
      full connection string
    Throws:
      `SQLException` - if connection string cannot be obtained.

  - ### getDatabasePath

    public static String getDatabasePath(GDSType gdsType, String jdbcUrl) throws SQLException
    Get path to the database from the specified JDBC URL. This method finds the appropriate plugin and delegates the call to it. Plugin is responsible for the call execution.
    Parameters:
      `gdsType` - type of the plugin, to which operation will be delegated to.
      `jdbcUrl` - JDBC url from which the database path must be extracted.
    Returns:
      path to the database specified in the JDBC URL.
    Throws:
      `SQLException` - error when database path cannot be extracted.

  - ### getSupportedProtocols

    public static Set<String> getSupportedProtocols()
    Get collection of the supported JDBC protocols.
    Returns:
      set of the supported protocols.

  - ### getJdbcUrl

    public static String getJdbcUrl(GDSType gdsType, DatabaseConnectionProperties dbConnectionProperties) throws SQLException
    Create JDBC URL for the specified GDS type and database connection properties.
    Parameters:
      `gdsType` - type of the plugin, to which operation will be delegated to.
      `dbConnectionProperties` - Database connection properties
    Returns:
      newly created JDBC URL
    Throws:
      `SQLException` - When required information is missing to build the URL

  - ### getTypeForProtocol

    public static GDSType getTypeForProtocol(String jdbcUrl)
    Get GDS type for the specified JDBC URL. This method finds the plugin corresponding to the specified type and delegates the call to it.
    Parameters:
      `jdbcUrl` - JDBC URL for which GDS type should be obtained.
    Returns:
      instance of `GDSType`.

  - ### getConnectionClass

    public static Class<?> getConnectionClass(GDSType gdsType)
    Get class extending the `FBConnection` that will be instantiated when new connection is created. This method finds the plugin for the specified type and delegates the call to it.
    Parameters:
      `gdsType` - instance of `GDSType`
    Returns:
      class to instantiate for the database connection.

  - ### getPlugin

    @InternalApi public static GDSFactoryPlugin getPlugin(GDSType gdsType)
    Get plugin for the specified GDS type.
    Parameters:
      `gdsType` - GDS type.
    Returns:
      instance of `GDSFactoryPlugin`
    Throws:
      `IllegalArgumentException` - if specified type is not known.